<?php

namespace Schaffen\SerasaRemessa\Http\Basic\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class RegP002 extends Record {
    protected $templateColumns = [
        [
            'name' => "tipo_reg", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 1,
            'size' => 4
        ],
        [
            'name' => "cod1", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 5,
            'size' => 4
        ],
        [
            'name' => "chave1", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 9,
            'size' => 21
        ],
        [
            'name' => "cod2", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 30,
            'size' => 4
        ],
        [
            'name' => "chave2", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 34,
            'size' => 21
        ],
        [
            'name' => "cod3", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 55,
            'size' => 4
        ],
        [
            'name' => "chave3", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 59,
            'size' => 21
        ],
        [
            'name' => "cod4", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 80,
            'size' => 4
        ],
        [
            'name' => "chave4", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 84,
            'size' => 21
        ],
        [
            'name' => "filler", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 105,
            'size' => 11
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();

        if($values !== null) {
            $this->setValues($values);
        }
    }

    private function setValues($values) {
        $values['tipo_reg'] = "P002";
        $values['cod1'] = "RE02";
        $values['chave1'] = "";
        $values['cod2'] = "REHM";
        $values['chave2'] = "HSPN";
        $values['cod3'] = "";
        $values['chave3'] = "";
        $values['cod4'] = "";
        $values['chave4'] = "";
        $values['filler'] = "";

        $this->setColumnsValues($values);
    }
}